## fq 0.0.5

=== Makefile ===
GO_BUILD_FLAGS ?= -trimpath
GO_BUILD_LDFLAGS ?= -s -w
GO_TEST_RACE_FLAGS ?=-race

all: test fq

.PHONY: fq
fq:
	CGO_ENABLED=0 go build -o fq -ldflags "${GO_BUILD_LDFLAGS}" ${GO_BUILD_FLAGS} .

.PHONY: test
test: testgo testjq testcli

.PHONY: testgo
# figure out all go pakges with test files
testgo: PKGS=$(shell find . -name "*_test.go" | xargs -n 1 dirname | sort | uniq)
testgo:
	go test ${GO_TEST_RACE_FLAGS} ${VERBOSE} ${COVER} ${PKGS}

.PHONY: testjq
testjq: fq
	@pkg/interp/testjq.sh ./fq pkg/interp/*_test.jq

.PHONY: testcli
testcli: fq
	@pkg/cli/test.sh ./fq pkg/cli/test.exp

.PHONY: cover
cover: COVER=-cover -coverpkg=./... -coverprofile=cover.out
cover: test
	go tool cover -html=cover.out -o cover.out.html
	cat cover.out.html | grep '<option value="file' | sed -E 's/.*>(.*) \((.*)%\)<.*/\2 \1/' | sort -rn

.PHONY: doc
doc: doc/formats.svg doc/demo.svg
doc: doc/display_json.svg
doc: doc/display_decode_value.svg
doc: doc/display_decode_value_d.svg
doc: doc/display_decode_value_dv.svg
	@doc/mdsh.sh ./fq *.md doc/*.md

doc/%.svg: doc/%.sh fq
	(cd doc ; ../$< ../fq) | go run github.com/wader/ansisvg@master > $@

.PHONY: doc/formats.svg
doc/formats.svg: fq
# ignore graphviz version as it causes diff when nothing has changed
	./fq -rnf doc/formats_diagram.jq | dot -Tsvg | sed 's/Generated by graphviz.*//' > doc/formats.svg

doc/file.mp3: Makefile
	ffmpeg -y -f lavfi -i sine -f lavfi -i testsrc -map 0:0 -map 1:0 -t 20ms "$@"

doc/file.mp4: Makefile
	ffmpeg -y -f lavfi -i sine -f lavfi -i testsrc -c:a aac -c:v h264 -f mp4 -t 20ms "$@"

.PHONY: gogenerate
gogenerate:
	go generate -x ./...

.PHONY: lint
lint:
# bump: make-golangci-lint /golangci-lint@v([\d.]+)/ git:https://github.com/golangci/golangci-lint.git|^1
	go run github.com/golangci/golangci-lint/cmd/golangci-lint@v1.44.0 run

.PHONY: depgraph.svg
depgraph.svg:
	go run github.com/kisielk/godepgraph@latest github.com/wader/fq | dot -Tsvg -o godepgraph.svg

# make memprof ARGS=". test.mp3"
# make cpuprof ARGS=". test.mp3"
.PHONY: prof
prof:
	go build -tags profile -o fq.prof fq.go
	CPUPROFILE=fq.cpu.prof MEMPROFILE=fq.mem.prof ./fq.prof ${ARGS}
.PHONY: memprof
memprof: prof
	go tool pprof -http :5555 fq.prof fq.mem.prof

.PHONY: cpuprof
cpuprof: prof
	go tool pprof -http :5555 fq.prof fq.cpu.prof

.PHONY: update-gomod
update-gomod:
	GOPROXY=direct go get -d github.com/wader/readline@fq
	GOPROXY=direct go get -d github.com/wader/gojq@fq
	go mod tidy

# TODO: as decode recovers panic and "repanics" unrecoverable errors this is a bit hacky at the moment
# fuzz code is not suppose to print to stderr so log to file
.PHONY: fuzz
fuzz:
# in other terminal: tail -f /tmp/repanic
	REPANIC_LOG=/tmp/repanic gotip test -tags fuzz -v -run Fuzz -fuzz=Fuzz ./format/

# usage: make release VERSION=0.0.1
# tag forked dependeces for history and to make then stay around
.PHONY: release
release: WADER_GOJQ_COMMIT=$(shell go list -m -f '{{.Version}}' github.com/wader/gojq | sed 's/.*-\(.*\)/\1/')
release: WADER_READLINE_COMMIT=$(shell go list -m -f '{{.Version}}' github.com/wader/readline | sed 's/.*-\(.*\)/\1/')
release:
	@echo "# wader/fq":
	@echo "# make sure head is at wader/master"
	@echo git fetch wader
	@echo git show
	@echo make lint test doc
	@echo go mod tidy
	@echo git diff
	@echo
	@echo "sed 's/version = "\\\(.*\\\)"/version = \"${VERSION}\"/' fq.go > fq.go.new && mv fq.go.new fq.go"
	@echo git add fq.go
	@echo git commit -m \"fq: Update version to ${VERSION}\"
	@echo git push wader master
	@echo
	@echo "# make sure head master commit CI was successful"
	@echo open https://github.com/wader/fq/commit/master
	@echo git tag v${VERSION}
	@echo
	@echo "# wader/gojq:"
	@echo git tag fq-v${VERSION} ${WADER_GOJQ_COMMIT}
	@echo git push wader fq-v${VERSION}:fq-v${VERSION}
	@echo
	@echo "# wader/readline:"
	@echo git tag fq-v${VERSION} ${WADER_READLINE_COMMIT}
	@echo git push wader fq-v${VERSION}:fq-v${VERSION}
	@echo
	@echo "# wader/fq":
	@echo git push wader v${VERSION}:v${VERSION}
	@echo "# edit draft release notes and publish"

=== format/elf/testdata/Makefile ===
TARGETS=libbbb.o libbbb.so libbbb.a a.o a_dynamic a_stripped a_static

all: $(TARGETS)

all-platforms:
	make build PLATFORM=linux/amd64 DIR=linux_amd64
	make build PLATFORM=linux/arm64 DIR=linux_arm64
	make build PLATFORM=linux/386 DIR=linux_386
	make build PLATFORM=linux/arm/v6 DIR=linux_arm_v6
	make build PLATFORM=linux/arm/v7 DIR=linux_arm_v7

clean:
	rm -f $(TARGETS)

build:
	docker run -ti --rm --platform $(PLATFORM) -v "$(PWD):$(PWD)" -w "$(PWD)" alpine:3.15.0 sh -c 'apk add build-base && make'
	mkdir -p $(DIR)
	mv $(TARGETS) $(DIR)
	rm $(DIR)/*.o

libbbb.so: libbbb.o
	$(CC) -shared -o $@ $+
libbbb.a: libbbb.o
	ar ru $@ $+
	ranlib $@
a_dynamic: a.o
	$(CC) -o $@ $+ -L./ -lbbb
a_stripped: a_dynamic
	strip -o $@ $<
a_static: a.o libbbb.a
	$(CC) -o $@ $+ libbbb.a

=== debian/changelog ===
fq (0.0.5-1) unstable; urgency=medium

  [ Xentripetal ]
  * initial work for avro OCF files
  * Hook into registry, add codecs
  * Cleanup
  * Change avro codec to funcs
  * Regenerate docs
  * Cleanup for linting
  * Use existing scalar description helper
  * Initial pass on logical types
  * Undo change to doc/file.mp4. I have no idea how
    this got changed in the first place? Maybe some macos shenanigans.
  * cleanup some docs, change enum to mapper, error zigzag on more than 8 bytes
  * Update linting
  * Parse header using avro decoders. Still not certain
    this is the best idea. Will get opinions before finalizing.
  * Add test case with all data types

  [ Mattias Wadman ]
  * goreleaser: Use zip for macos
  * doc: Add macOS security notes and move supported format up a bit
  * id3v2: Should assert not validate magic
  * zip: Assert signature not validate
  * interp: Fix handling of group decode error from stdin
  * pcapng,fuzz: Fix infinite loop by fatal error on block length <= 0
  * mp4,fuzz: Fatal error on infinite sgpd box entries
  * mpeg_spu: Fatal error on infinite loop
  * fuzz: Fuzz all formats
  * interp: Use correct sym color
  * interp: Add grep_by/1 to recursively match using a filter
  * mp3: Decrease max sync seek length between frames to 4k

  [ bump ]
  * Update make-golangci-lint from 1.43.0 to 1.44.0
  * Update github-golangci-lint from 1.43.0 to 1.44.0

  [ Mattias Wadman ]
  * lint: Fix typeassert and case exhaustive warnings
  * github: Add basic issue template

  [ Joel Rangsmo ]
  * Polish of problem template and clarifying questions
  * Remove redudant question and fix typo

  [ Mattias Wadman ]
  * fq: Add arch and os to --version
  * doc: Use f($a; $b) instead of jq f/2 notation
  * decode,scalar: Add scalar.Str{Uint/Int/F}ToSym to parse numbers
  * interp: Cleanup display aliases, now: d, da, dd, dv, ddv
  * interp: Add Platform() method to OS interface
  * doc: Add per format documentation
  * doc,matroska: Fix filesname in example
  * doc,interp: Add some example usages to cli help
  * make: Cleanup some not very used targets
  * doc: Document display and some more jq hints
  * doc: More display alias leftover fixes
  * protobuf: Add note about sub message decoding
  * decode: Add scalars args to FieldRootBitBuf
  * doc: Color edges in diagram based on dest
  * bitio,decode: Refactor bitio usage and make buffer slicing more correct
  * bitio: Cleanup documentation a bit
  * mp4: Add video preview (pnot) and JPEG 2000 (jP) signatures
  * interp: Support force decode as -o force=true
  * doc: Add format links to format table
  * fuzz: List seed numbers and make it build again
  * decode: Rename LenFn() to LimitedFn, add FramedFn and document
  * asn1_ber: Add decoder
  * mp4: Add stz2 support
  * aac_frame: Only try decode object types we know about
  * interp: Add missing default opts for tovalue
  * asn1_ber: Add more doc and multiple outputs for frompem

  [ Xentripetal ]
  * Change tests to use new verbose syntax
  * Support snappy and deflate codecs
  * Fix lint

  [ Mattias Wadman ]
  * binary,decode,doc: Rename buffer to binary and add some documentation
  * bitio: More doc cleanup
  * bitio,doc: Even more cleanup
  * doc: Cleanup and add more decode value and binary documentation

  [ Xentripetal ]
  * Timestamps should be UTC
  * Cleanup snappy
  * Lint and add basic doc
  * Take heading off doc to match make doc format

  [ Thushan Fernando ]
  * Adds Windows Scoop instructions for fq.

  [ Mattias Wadman ]
  * doc: Add more license details

  [ Xentripetal ]
  * Dates need to specify UTC too
  * Comment on snappy decompression

  [ Mattias Wadman ]
  * interp: Refactor radix* into toradix($base)/fromradix($base)
  * interp: Use absolute path in errors

  [ bump ]
  * Update docker-golang from 1.17.6 to 1.17.7
  * Update github-go-version from 1.17.6, 1.17.6 to 1.17.7

  [ Mattias Wadman ]
  * interp: Add paste function to allow pasting text into REPL etc
  * repl: Fix completion of non-underscore extkeys
  * repl,interp: Make stdio work during completion
  * fuzz: Make it compile again and run one format per fuzz
  * gojq: Rebase fq branch
  * mpeg_spu: Fatal error on unknown cmd
  * doc: Add inital decoder API documentation

  [ Xentripetal ]
  * simplify scalar usage
  * make doc

  [ Mattias Wadman ]
  * doc: Unbreak formats_digaram.jq since radix change
  * bump: Add snappy config
  * doc: Add snappy license
  * doc: More decode API details and polish
  * doc: Add CHANGES.md documenting release changes
  * fq: Update version to 0.0.5

  [ Daniel Milde ]
  * d/control: fq conflicts with nq (Closes: 1005961)

 -- Daniel Milde <daniel@milde.cz>  Sat, 19 Feb 2022 23:12:58 +0100

fq (0.0.4-2) unstable; urgency=medium

  * Team upload.
  * Re-upload as source only

 -- Stephen Gelman <ssgelm@debian.org>  Thu, 17 Feb 2022 14:32:22 -0600

fq (0.0.4-1) unstable; urgency=medium

  * Initial release (Closes: 1002452)

 -- Daniel Milde <daniel@milde.cz>  Sat, 22 Jan 2022 00:38:15 +0100

=== debian/control ===
Source: fq
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Daniel Milde <daniel@milde.cz>
Section: utils
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               golang-any,
               golang-github-golang-snappy-dev,
               golang-github-google-gopacket-dev,
               golang-github-mitchellh-mapstructure-dev,
               golang-github-pmezard-go-difflib-dev,
               golang-golang-x-text-dev,
               golang-github-wader-readline-dev,
               golang-github-wader-gojq-dev,
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/go-team/packages/fq
Vcs-Git: https://salsa.debian.org/go-team/packages/fq.git
Homepage: https://github.com/wader/fq
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/wader/fq

Package: fq
Architecture: any
Conflicts: nq
Depends: ${misc:Depends},
         ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Description: jq for binary formats (program)
 Tool, language and decoders for inspecting binary data.
 .
 In most cases fq works the same way as jq but instead of reading JSON it
 reads binary data. The result is a JSON compatible structures where each
 value has a bit range, symbolic interpretations and know how to be
 presented in a useful way.

=== debian/rules ===
#!/usr/bin/make -f

export DH_GOLANG_INSTALL_EXTRA := ./dev/x264sei.jq \
	./dev/editlist.jq \
	./dev/format_summary.jq \
	./dev/snippets.jq \
	./doc/formats_table.jq \
	./doc/formats_list.jq \
	./doc/formats_diagram.jq \
	./format/bencode/bencode.jq \
	./format/cbor/cbor.jq \
	./format/matroska/matroska.jq \
	./format/mp4/mp4.jq \
	./format/asn1/asn1_ber.jq \
	./format/msgpack/msgpack.jq \
	./format/bson/bson.jq \
	./pkg/interp/internal.jq \
	./pkg/interp/query_test.jq \
	./pkg/interp/match.jq \
	./pkg/interp/assert.jq \
	./pkg/interp/decode.jq \
	./pkg/interp/funcs.jq \
	./pkg/interp/grep.jq \
	./pkg/interp/options.jq \
	./pkg/interp/repl.jq \
	./pkg/interp/args.jq \
	./pkg/interp/query.jq \
	./pkg/interp/funcs_test.jq \
	./pkg/interp/binary.jq \
	./pkg/interp/formats.jq \
	./pkg/interp/args_test.jq \
	./pkg/interp/interp.jq

export DH_GOLANG_EXCLUDES := format/matroska/ebml/gen dev doc

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

override_dh_auto_install:
	dh_auto_install -- --no-source

## fq 0.0.6

=== debian/changelog ===
fq (0.0.6-1ubuntu0.1) kinetic-security; urgency=medium

  * No-change rebuild for golang-golang-x-text

 -- Eduardo Barretto <eduardo.barretto@canonical.com>  Mon, 13 Feb 2023 14:47:07 +0100

fq (0.0.6-1) unstable; urgency=medium

  [ Mattias Wadman ]
  * interp: Move _is_decode_value to jq
  * doc: Improve project description
  * dev: Add .jq-lsp.jq to add additional builtins for jq-lsp
  * doc,asn1_ber: Add more documentation
  * doc: Forgot make doc
  * decode: Some cleanup

  [ bump ]
  * Update make-golangci-lint from 1.44.0 to 1.44.1
  * Update github-golangci-lint from 1.44.0 to 1.44.1

  [ Mattias Wadman ]
  * doc: Improve and fix some typos
  * repl: Speedup multi input to sub-repl

  [ bump ]
  * Update make-golangci-lint from 1.44.1 to 1.44.2
  * Update github-golangci-lint from 1.44.1 to 1.44.2

  [ Mattias Wadman ]
  * repl: Add comments and query from/to  helper
  * doc: Add href in supported format list
  * interp: Move opts eval to options.jq

  [ siddik.acil ]
  * macho: barebones decoder impl
  * macho: magicToHex to scalar.Hex
  * macho: add nolint suppression to const defs
  * macho: little-endian to little_endian
  * macho: change registry description
  * macho: use FieldUTF8NullFixedLen
  * macho: adopt plural-singular scheme for FieldStructArrayLoop
  * macho: add scalar.Hex mapper to addr fields
  * macho: use FieldUTF8NullFixedLen for segname
  * macho: generate doc via make doc
  * macho: fix FieldUTF8NullFixedLen for segname
  * macho: add cpuSubTypes
  * macho: make actual
  * macho: discard lc_ and lowercase command names
  * macho: ntools fix LC_MAIN fix
  * macho: add darwin_amd64 tests
  * macho: mach_header_X to header
  * macho: fix null in segname sectname
  * macho: add fqtest actualization
  * macho: basic impl for ar and fat file parsing
  * macho: reuse ar decoder
  * macho: linting changes for ar parse
  * macho: expand filetypes and header flags
  * macho: parse segment section flags
  * macho: refactor prebound_dylib
  * macho: delete ar decoder code
  * macho: add section type parsing
  * macho: update tests
  * macho: change parseFlags impl for ordered results
  * macho: timestamp mapper
  * macho: thread state visualization
  * macho: simplify thread state decoder
  * macho: update test cases v to dv
  * macho: TS string to UTC
  * macho: review fixes
  * macho: CPU_SUBTYPE_MULTIPLE and TYPE_ALL are 0xff_ff_ff_ff
  * fixup! macho: CPU_SUBTYPE_MULTIPLE and TYPE_ALL are 0xff_ff_ff_ff
  * macho: fix fat header decode bug
  * macho: introduce arm and fat tests
  * macho: handle unknown lc_commands better
  * macho: parse flags individually
  * macho: review fixes
  * macho: remake docs

  [ Mattias Wadman ]
  * fuzz: Include more testdata seed files
  * interp: Skip redundant includes
  * interp: Make _finally handle null, call fin once and last

  [ siddik.acil ]
  * macho: add basic docs
  * macho: docs review changes

  [ Mattias Wadman ]
  * doc: Regenerate after macho merge
  * doc: Tweak format diagram
  * mp4: Add colr box support
  * mp4: Reformat and use dv in test
  * repl,interp: Refactor repl and slurp
  * gojq: Rebase fq fork and add support for non-10 base for tonumber
  * doc: Regenerate and fix macho section size
  * interp: Color parse in jq
  * interp,repl: Add path and value colors to prompt
  * interp: Rework formats and options help
  * repl: Correct error arrow position in color mode
  * interp: Make help output less wide

  [ bump ]
  * Update docker-golang from 1.17.7 to 1.17.8

  [ Mattias Wadman ]
  * test: Make expect cli test more robust
  * format: Simplify torepr, no need for _f function
  * doc: Add fq bts2022 presentation
  * interp: Cleanup binary regexp overloading and add explode
  * doc: Add bts2022 video
  * interp: Fix interrupt regression after query rewrite refactor
  * interp,repl: Improved eval and output interrupt
  * doc: Add 0.0.6 changes
  * fq: Update version to 0.0.6

 -- Daniel Milde <daniel@milde.cz>  Tue, 22 Mar 2022 22:09:19 +0100

=== debian/rules ===
#!/usr/bin/make -f

export DH_GOLANG_INSTALL_EXTRA := ./dev/x264sei.jq \
	./dev/editlist.jq \
	./dev/format_summary.jq \
	./dev/snippets.jq \
	./format/bencode/bencode.jq \
	./format/cbor/cbor.jq \
	./format/matroska/matroska.jq \
	./format/mp4/mp4.jq \
	./format/asn1/asn1_ber.jq \
	./format/msgpack/msgpack.jq \
	./format/bson/bson.jq \
	./pkg/interp/internal.jq \
	./pkg/interp/query_test.jq \
	./pkg/interp/.jq-lsp.jq \
	./pkg/interp/assert.jq \
	./pkg/interp/help.jq \
	./pkg/interp/decode.jq \
	./pkg/interp/funcs.jq \
	./pkg/interp/grep.jq \
	./pkg/interp/options.jq \
	./pkg/interp/repl.jq \
	./pkg/interp/args.jq \
	./pkg/interp/eval.jq \
	./pkg/interp/query.jq \
	./pkg/interp/funcs_test.jq \
	./pkg/interp/binary.jq \
	./pkg/interp/formats.jq \
	./pkg/interp/args_test.jq \
	./pkg/interp/ansi.jq \
	./pkg/interp/interp.jq

export DH_GOLANG_EXCLUDES := format/matroska/ebml/gen dev/ doc/
export DH_GOLANG_BUILDPKG := github.com/wader/fq

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

override_dh_auto_install:
	dh_auto_install -- --no-source

## fq 0.2.0

=== Makefile ===
GO_BUILD_FLAGS ?= -trimpath
GO_BUILD_LDFLAGS ?= -s -w

all: test fq

# used to force make to always redo
.PHONY: always

fq: always
	CGO_ENABLED=0 go build -o fq -ldflags "${GO_BUILD_LDFLAGS}" ${GO_BUILD_FLAGS} .

test: always testgo testjq testcli
test-race: always testgo-race testjq testcli

# figure out all go packages with test files
testgo: PKGS=$(shell find . -name "*_test.go" | xargs -n 1 dirname | sort | uniq)
testgo: always
	go test -timeout 20m ${RACE} ${VERBOSE} ${COVER} ${PKGS}

testgo-race: RACE=-race
testgo-race: testgo

testjq: $(shell find . -name "*.jq.test")
%.jq.test: fq
	@echo $@
	@./fq -rRs -L pkg/interp 'include "jqtest"; run_tests' $@

testcli: fq
	@pkg/cli/test_exp.sh ./fq pkg/cli/test_repl.exp
	@pkg/cli/test_exp.sh ./fq pkg/cli/test_cli_ctrlc.exp
	@pkg/cli/test_exp.sh ./fq pkg/cli/test_cli_ctrld.exp

cover: COVER=-cover -coverpkg=./... -coverprofile=cover.out
cover: test
	go tool cover -html=cover.out -o cover.out.html
	cat cover.out.html | grep '<option value="file' | sed -E 's/.*>(.*) \((.*)%\)<.*/\2 \1/' | sort -rn

doc: always
doc: $(wildcard doc/*.svg)
doc: $(wildcard *.md doc/*.md)

%.md: fq
	@doc/mdsh.sh ./fq $@

doc/%.svg: fq
	(cd doc ; ../$@.sh ../fq) | go run github.com/wader/ansisvg@master > $@

doc/formats.svg: fq
	@# ignore graphviz version as it causes diff when nothing has changed
	./fq -rnf doc/formats_diagram.jq | dot -Tsvg | sed 's/Generated by graphviz.*//' >doc/formats.svg

doc/file.mp3: Makefile
	ffmpeg -y -f lavfi -i sine -f lavfi -i testsrc -map 0:0 -map 1:0 -t 20ms "$@"

doc/file.mp4: Makefile
	ffmpeg -y -f lavfi -i sine -f lavfi -i testsrc -c:a aac -c:v h264 -f mp4 -t 20ms "$@"

gogenerate: always
	go generate -x ./...

lint: always
# bump: make-golangci-lint /golangci-lint@v([\d.]+)/ git:https://github.com/golangci/golangci-lint.git|^1
# bump: make-golangci-lint link "Release notes" https://github.com/golangci/golangci-lint/releases/tag/v$LATEST
	go run github.com/golangci/golangci-lint/cmd/golangci-lint@v1.50.1 run

depgraph.svg: always
	go run github.com/kisielk/godepgraph@latest github.com/wader/fq | dot -Tsvg -o godepgraph.svg

# make memprof ARGS=". test.mp3"
# make cpuprof ARGS=". test.mp3"
prof: always
	go build -tags profile -o fq.prof .
	CPUPROFILE=fq.cpu.prof MEMPROFILE=fq.mem.prof ./fq.prof ${ARGS}
memprof: prof
	go tool pprof -http :5555 fq.prof fq.mem.prof
cpuprof: prof
	go tool pprof -http :5555 fq.prof fq.cpu.prof

update-gomod: always
	GOPROXY=direct go get -d github.com/wader/readline@fq
	GOPROXY=direct go get -d github.com/wader/gojq@fq
	go mod tidy

# Usage: make fuzz # fuzz all foramts
# Usage: make fuzz GROUP=mp4 # fuzz a group (each format is a group also)
# TODO: as decode recovers panic and "repanics" unrecoverable errors this is a bit hacky at the moment
# Retrigger:
# try to decode crash with all formats in order to see which one paniced:
# cat format/testdata/fuzz/FuzzFormats/... | go run dev/fuzzbytes.go | go run . -d bytes '. as $b | formats | keys[] as $f | $b | decode($f)'
# convert crash into raw bytes:
# cat format/testdata/fuzz/FuzzFormats/... | go run dev/fuzzbytes.go | fq -d bytes to_base64
# fq -n '"..." | from_base64 | ...'
fuzz: always
# in other terminal: tail -f /tmp/repanic
	FUZZTEST=1 REPANIC_LOG=/tmp/repanic go test -v -run Fuzz -fuzz=Fuzz ./format/

# usage: make release VERSION=0.0.1
# tag forked dependeces for history and to make then stay around
release: always
release: WADER_GOJQ_COMMIT=$(shell go list -m -f '{{.Version}}' github.com/wader/gojq | sed 's/.*-\(.*\)/\1/')
release: WADER_READLINE_COMMIT=$(shell go list -m -f '{{.Version}}' github.com/wader/readline | sed 's/.*-\(.*\)/\1/')
release:
	@echo "# wader/fq":
	@echo "# make sure head is at wader/master"
	@echo git fetch wader
	@echo git show
	@echo make lint test doc
	@echo go mod tidy
	@echo git diff
	@echo
	@echo "sed 's/version = "\\\(.*\\\)"/version = \"${VERSION}\"/' fq.go > fq.go.new && mv fq.go.new fq.go"
	@echo git add fq.go
	@echo git commit -m \"fq: Update version to ${VERSION}\"
	@echo git push wader master
	@echo
	@echo "# make sure head master commit CI was successful"
	@echo open https://github.com/wader/fq/commit/master
	@echo git tag v${VERSION}
	@echo
	@echo "# wader/gojq:"
	@echo git tag fq-v${VERSION} ${WADER_GOJQ_COMMIT}
	@echo git push wader fq-v${VERSION}:fq-v${VERSION}
	@echo
	@echo "# wader/readline:"
	@echo git tag fq-v${VERSION} ${WADER_READLINE_COMMIT}
	@echo git push wader fq-v${VERSION}:fq-v${VERSION}
	@echo
	@echo "# wader/fq":
	@echo git push wader v${VERSION}:v${VERSION}
	@echo "# edit draft release notes and publish"

=== debian/changelog ===
fq (0.2.0-1) unstable; urgency=medium

  * New upstream release

 -- Daniel Milde <daniel@milde.cz>  Fri, 06 Jan 2023 20:50:20 +0100

fq (0.0.9-2) unstable; urgency=medium

  * Added dependencies (Closes: 1023153)

 -- Daniel Milde <daniel@milde.cz>  Mon, 31 Oct 2022 22:05:12 +0100

fq (0.0.9-1) unstable; urgency=medium

  * New upstream release
  * d/control: added new dependencies
  * d/rules: more files to install
  * d/control: gojq version
  * d/copyright: file moved

 -- Daniel Milde <daniel@milde.cz>  Sat, 29 Oct 2022 20:57:05 +0200

## fq 0.3.0

=== Makefile ===
--- 
+++ 
@@ -61,7 +61,7 @@
 lint: always
 # bump: make-golangci-lint /golangci-lint@v([\d.]+)/ git:https://github.com/golangci/golangci-lint.git|^1
 # bump: make-golangci-lint link "Release notes" https://github.com/golangci/golangci-lint/releases/tag/v$LATEST
-	go run github.com/golangci/golangci-lint/cmd/golangci-lint@v1.50.1 run
+	go run github.com/golangci/golangci-lint/cmd/golangci-lint@v1.51.0 run
 
 depgraph.svg: always
 	go run github.com/kisielk/godepgraph@latest github.com/wader/fq | dot -Tsvg -o godepgraph.svg

=== format/elf/testdata/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-TARGETS=libbbb.o libbbb.so libbbb.a a.o a_dynamic a_stripped a_static
+TARGETS=libbbb.o libbbb.so libbbb.a a.o a_dynamic a_stripped a_static coredump
 
 all: $(TARGETS)
 
@@ -13,7 +13,7 @@
 	rm -f $(TARGETS)
 
 build:
-	docker run -ti --rm --platform $(PLATFORM) -v "$(PWD):$(PWD)" -w "$(PWD)" alpine:3.15.0 sh -c 'apk add build-base && make'
+	docker run -ti --rm --platform $(PLATFORM) -v "$(PWD):$(PWD)" -w "$(PWD)" alpine:3.15.0 sh -c 'apk add build-base && ulimit -c unlimited && make'
 	mkdir -p $(DIR)
 	mv $(TARGETS) $(DIR)
 	rm $(DIR)/*.o
@@ -23,9 +23,17 @@
 libbbb.a: libbbb.o
 	ar ru $@ $+
 	ranlib $@
+
 a_dynamic: a.o
 	$(CC) -o $@ $+ -L./ -lbbb
+
 a_stripped: a_dynamic
 	strip -o $@ $<
+
 a_static: a.o libbbb.a
 	$(CC) -o $@ $+ libbbb.a
+
+segfault: segfault.o
+	$(CC) -o $@ $<
+coredump: segfault
+	./segfault ; mv core coredump ; rm -f segfault segfault.o ; exit 0

=== debian/changelog ===
fq (0.3.0-1) unstable; urgency=medium

  * New upstream release

 -- Daniel Milde <daniel@milde.cz>  Sun, 26 Feb 2023 22:18:46 +0100

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,14 @@
                golang-github-pmezard-go-difflib-dev,
                golang-golang-x-text-dev,
                golang-github-wader-readline-dev,
-               golang-github-wader-gojq-dev,
+               golang-github-wader-gojq-dev (>= 0.0~git20220822.64fe65a-1),
+               golang-github-creasty-defaults-dev,
+               golang-github-gopacket-gopacket-dev,
+               golang-github-mitchellh-copystructure-dev,
+               golang-golang-x-exp-dev,
+               golang-github-burntsushi-toml-dev,
+               golang-golang-x-crypto-dev,
+               golang-github-gomarkdown-markdown-dev,
 Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/go-team/packages/fq
 Vcs-Git: https://salsa.debian.org/go-team/packages/fq.git

=== debian/rules ===
#!/usr/bin/make -f

export DH_GOLANG_INSTALL_EXTRA := ./dev/x264sei.jq \
	./dev/editlist.jq \
	./dev/format_summary.jq \
	./dev/snippets.jq \
	./doc/formats.jq \
	./doc/formats_diagram.jq \
	./format/bencode/bencode.jq \
	./format/yaml/yaml.jq \
	./format/cbor/cbor.jq \
	./format/matroska/matroska.jq \
	./format/xml/xml.jq \
	./format/xml/html.jq \
	./format/crypto/pem.jq \
	./format/crypto/hash.jq \
	./format/text/encoding.jq \
	./format/toml/toml.jq \
	./format/mp4/mp4.jq \
	./format/asn1/asn1_ber.jq \
	./format/math/radix.jq \
	./format/msgpack/msgpack.jq \
	./format/bson/bson.jq \
	./format/markdown/markdown.jq \
	./format/csv/csv.jq \
	./format/apple/bookmark/apple_bookmark.jq \
	./format/apple/bplist/bplist.jq \
	./format/apple/bplist/ns_keyed_archiver.jq \
	./format/json/jsonl.jq \
	./format/json/jq.jq \
	./format/json/json.jq \
	./pkg/interp/internal.jq \
	./pkg/interp/init.jq \
	./pkg/interp/.jq-lsp.jq \
	./pkg/interp/help.jq \
	./pkg/interp/decode.jq \
	./pkg/interp/format_func.jq \
	./pkg/interp/funcs.jq \
	./pkg/interp/jqtest.jq \
	./pkg/interp/format_decode.jq \
	./pkg/interp/grep.jq \
	./pkg/interp/options.jq \
	./pkg/interp/repl.jq \
	./pkg/interp/args.jq \
	./pkg/interp/eval.jq \
	./pkg/interp/query.jq \
	./pkg/interp/binary.jq \
	./pkg/interp/ansi.jq \
	./pkg/interp/interp.jq \
	./pkg/interp/registry_include.jq \
	./format/bencode/bencode.md \
	./format/rtmp/testdata/README.md \
	./format/rtmp/rtmp.md \
	./format/cbor/cbor.md \
	./format/matroska/matroska.md \
	./format/bits/bits.md \
	./format/bits/bytes.md \
	./format/zip/zip.md \
	./format/xml/html.md \
	./format/xml/xml.md \
	./format/wasm/wasm.md \
	./format/avro/avro_ocf.md \
	./format/mp4/mp4.md \
	./format/asn1/asn1_ber.md \
	./format/asn1/testdata/README.md \
	./format/pcap/pcap.md \
	./format/protobuf/protobuf.md \
	./format/msgpack/msgpack.md \
	./format/bson/bson.md \
	./format/markdown/markdown.md \
	./format/markdown/testdata/test.md \
	./format/tzif/tzif.md \
	./format/flac/testdata/README.md \
	./format/csv/csv.md \
	./format/riff/avi.md \
	./format/apple/bookmark/apple_bookmark.md \
	./format/apple/bplist/bplist.md \
	./format/apple/macho/macho.md

export DH_GOLANG_EXCLUDES := format/matroska/ebml/gen dev/ doc/
export DH_GOLANG_BUILDPKG := github.com/wader/fq

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

override_dh_auto_install:
	dh_auto_install -- --no-source

## fq 0.9.0

=== Makefile ===
--- 
+++ 
@@ -36,14 +36,14 @@
 	cat cover.out.html | grep '<option value="file' | sed -E 's/.*>(.*) \((.*)%\)<.*/\2 \1/' | sort -rn
 
 doc: always
-doc: $(wildcard doc/*.svg)
+doc: $(wildcard doc/*.svg.sh)
 doc: $(wildcard *.md doc/*.md)
 
 %.md: fq
 	@doc/mdsh.sh ./fq $@
 
-doc/%.svg: fq
-	(cd doc ; ../$@.sh ../fq) | go run github.com/wader/ansisvg@master > $@
+doc/%.svg.sh: fq
+	(cd doc ; ../$@ ../fq) | go run github.com/wader/ansisvg@master > $(@:.svg.sh=.svg)
 
 doc/formats.svg: fq
 	@# ignore graphviz version as it causes diff when nothing has changed
@@ -61,7 +61,7 @@
 lint: always
 # bump: make-golangci-lint /golangci-lint@v([\d.]+)/ git:https://github.com/golangci/golangci-lint.git|^1
 # bump: make-golangci-lint link "Release notes" https://github.com/golangci/golangci-lint/releases/tag/v$LATEST
-	go run github.com/golangci/golangci-lint/cmd/golangci-lint@v1.51.0 run
+	go run github.com/golangci/golangci-lint/cmd/golangci-lint@v1.55.2 run
 
 depgraph.svg: always
 	go run github.com/kisielk/godepgraph@latest github.com/wader/fq | dot -Tsvg -o godepgraph.svg
@@ -85,14 +85,14 @@
 # Usage: make fuzz GROUP=mp4 # fuzz a group (each format is a group also)
 # TODO: as decode recovers panic and "repanics" unrecoverable errors this is a bit hacky at the moment
 # Retrigger:
-# try to decode crash with all formats in order to see which one paniced:
+# try to decode crash with all formats in order to see which one panicked:
 # cat format/testdata/fuzz/FuzzFormats/... | go run dev/fuzzbytes.go | go run . -d bytes '. as $b | formats | keys[] as $f | $b | decode($f)'
 # convert crash into raw bytes:
 # cat format/testdata/fuzz/FuzzFormats/... | go run dev/fuzzbytes.go | fq -d bytes to_base64
 # fq -n '"..." | from_base64 | ...'
 fuzz: always
 # in other terminal: tail -f /tmp/repanic
-	FUZZTEST=1 REPANIC_LOG=/tmp/repanic go test -v -run Fuzz -fuzz=Fuzz ./format/
+	FUZZTEST=1 go test -v -run Fuzz -fuzz=Fuzz ./format/
 
 # usage: make release VERSION=0.0.1
 # tag forked dependeces for history and to make then stay around

=== format/apple/macho/testdata/Makefile ===
TARGETS=libbbb.o libbbb.so a.o a_dynamic a_stripped a_static
GENERATED_FILES=$(TARGETS) libbbb.a

FQ:=fq

all: $(TARGETS)

all-platforms:
	make build DIR=darwin_amd64 CFLAGS='-target x86_64-apple-macos10.12'
	make build CC=clang DIR=darwin_aarch64 CFLAGS='-target arm64-apple-macos11'
	make build_fat_targets DIR=darwin_fat DIR_X86=darwin_amd64 DIR_ARM=darwin_aarch64

clean:
	rm -f $(TARGETS)

build:
	make
	mkdir -p $(DIR)
	mv $(GENERATED_FILES) $(DIR)
	rm $(DIR)/*.o

build_fat_targets:
	mkdir -p $(DIR)
	make build_fat DIR=$(DIR) OUTPUT=a_dynamic TARGET_X86=$(DIR_X86)/a_dynamic TARGET_ARM=$(DIR_ARM)/a_dynamic
	make build_fat DIR=$(DIR) OUTPUT=a_static TARGET_X86=$(DIR_X86)/a_static TARGET_ARM=$(DIR_ARM)/a_static
	make build_fat DIR=$(DIR) OUTPUT=libbbb.so TARGET_X86=$(DIR_X86)/libbbb.so TARGET_ARM=$(DIR_ARM)/libbbb.so
	make build_fat DIR=$(DIR) OUTPUT=a_stripped TARGET_X86=$(DIR_X86)/a_stripped TARGET_ARM=$(DIR_ARM)/a_stripped

# build_fat creates a FAT binary from TARGET_X86 and TARGET_ARM
# creates FAT binary $(OUTPUT) under $(DIR)
build_fat:
	lipo -create -output $(DIR)/$(OUTPUT) $(TARGET_X86) $(TARGET_ARM)

libbbb.so: libbbb.o
	$(CC) $(CFLAGS) -shared -o $@ $+
libbbb.a: libbbb.o
	ar ru $@ $+
	ranlib $@
a_dynamic: a.o
	$(CC) $(CFLAGS) -o $@ $+ -L./ -lbbb
a_stripped: a_dynamic
	strip -o $@ $<
a_static: a.o libbbb.a
	$(CC) $(CFLAGS) -o $@ $+ libbbb.a

all-platforms-actual:
	make actual DIR=darwin_amd64
	make actual DIR=darwin_aarch64
	make actual DIR=darwin_fat

# generates or actualizes the test cases
actual:
	cd $(DIR) && echo $(TARGETS) | tr -s '[:blank:]' '\n' | grep -ivE '.*\.o$$' | xargs -I '{}' sh -c 'echo "$$ fq dv {}" > {}.fqtest && $(FQ) -d macho dv {} >> {}.fqtest'

=== debian/changelog ===
fq (0.9.0-2) unstable; urgency=medium

  * Team upload
  * Use dh-sequence-golang instead of dh-golang and --with=golang
  * Update versioned dependencies as per go.mod
  * Replace Built-Using field with Static-Built-Using

 -- Anthony Fok <foka@debian.org>  Wed, 20 Dec 2023 11:39:10 -0700

fq (0.9.0-1) unstable; urgency=medium

  * Team upload
  * New upstream release (Closes: #1057403)

 -- Stephen Gelman <ssgelm@debian.org>  Fri, 15 Dec 2023 13:51:16 -0600

=== debian/control ===
Source: fq
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Daniel Milde <daniel@milde.cz>
Section: utils
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-sequence-golang,
               golang-any (>= 2:1.18~),
               golang-github-burntsushi-toml-dev (>= 1.3.2),
               golang-github-creasty-defaults-dev (>= 1.7.0),
               golang-github-golang-snappy-dev,
               golang-github-gomarkdown-markdown-dev,
               golang-github-gopacket-gopacket-dev (>= 1.2.0),
               golang-github-mitchellh-copystructure-dev,
               golang-github-mitchellh-mapstructure-dev,
               golang-github-pmezard-go-difflib-dev,
               golang-github-wader-gojq-dev (>= 0.0~git20231105.2b6d9e2),
               golang-github-wader-readline-dev (>= 0.0~git20230307.bcb7158),
               golang-golang-x-crypto-dev (>= 1:0.15.0),
               golang-golang-x-exp-dev (>= 0.0~git20230725.302865e),
               golang-golang-x-net-dev (>= 1:0.18.0),
               golang-golang-x-text-dev (>= 0.14.0),
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/go-team/packages/fq
Vcs-Git: https://salsa.debian.org/go-team/packages/fq.git
Homepage: https://github.com/wader/fq
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/wader/fq

Package: fq
Architecture: any
Conflicts: nq
Depends: ${misc:Depends},
         ${shlibs:Depends}
Static-Built-Using: ${misc:Static-Built-Using}
Description: jq for binary formats (program)
 Tool, language and decoders for inspecting binary data.
 .
 In most cases fq works the same way as jq but instead of reading JSON it
 reads binary data. The result is a JSON compatible structures where each
 value has a bit range, symbolic interpretations and know how to be
 presented in a useful way.

=== debian/rules ===
--- 
+++ 
@@ -75,13 +75,21 @@
 	./format/riff/avi.md \
 	./format/apple/bookmark/apple_bookmark.md \
 	./format/apple/bplist/bplist.md \
-	./format/apple/macho/macho.md
+	./format/apple/macho/macho.md \
+	./format/caff/caff.md \
+	./format/luajit/luajit.md \
+	./format/moc3/moc3.md \
+	./format/opentimestamps/opentimestamps.md \
+	./format/postgres/pg_btree.md \
+	./format/postgres/pg_control.md \
+	./format/postgres/pg_heap.md \
+	./format/tls/tls.md
 
 export DH_GOLANG_EXCLUDES := format/matroska/ebml/gen dev/ doc/
 export DH_GOLANG_BUILDPKG := github.com/wader/fq
 
 %:
-	dh $@ --builddirectory=_build --buildsystem=golang --with=golang
+	dh $@ --builddirectory=_build --buildsystem=golang
 
 override_dh_auto_install:
 	dh_auto_install -- --no-source

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,\
      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/$1~$2$3/" \
  https://github.com/wader/fq/tags .*/v?(\d\S*)\.tar\.gz debian
